/*follow.c
Verzija 1.0
Autor: Galic Voislav 97/97
******************ODREDJIVANJE FOLLOW SKUPOVA ZADATE GRAMATIKE******************
Gramatika se cita iz ulaz.txt, a rezultat upisuje u izlaz.txt! Leva strana smene
zadaje se na pocetku novog reda, ide blanko pa desna strana smene(za prazne smene
zadaje se samo leva strana smene bez blanka!). Pretpostavljeno je da desna strana
smene ne prelazi 10 simbola i da je maksimalni broj smena 50, a da terminalni
simbol moze da bude bilo koji stampajuci simbol iz ASCII tablice izuzev velikog
slova, blanka i znaka @ koji se koristi kao marker kraja ulaza, dakle ukupno je
moguce 69 terminala*/

#include<stdio.h>
#include<string.h>
#define MAX_S 50
#define MAX_D 10
#define MAX_T 69

char L[MAX_S];
char D[MAX_S][MAX_D];
int  P[128];
char FIRST[128][MAX_T+1];
char FOLLOW[128][MAX_T+1];
int  br_smena;

/*ucitavanje gramatike iz ulaz.txt*/
void ucitaj(){
     FILE *ulaz;
     char line[80];
     br_smena=0;
     ulaz=fopen("ulaz.txt","r");
     while( fgets(line, 14, ulaz)!=NULL ){
            L[br_smena]=line[0];
            if(strlen(line)>1){
               strcpy(D[br_smena],line+2);
               /*sledi zamena '\n' sa '\0'*/
               D[br_smena][strlen(line)-3]='\0';
            }else strcpy(D[br_smena],"");
            br_smena++;
     }
     fclose(ulaz);
}

/*provera da li se karakter nalazi u nizu karaktera*/
int sadrzi(char *string, char c){
    int i;
    for(i=0;i<strlen(string);i++)
        if(string[i]==c)
           return 1;
    return 0;
}

/*izracunavanje ponistivih neterminala; first i follow skupova*/
void follow(){
     int ponovo, i, j, k, l, ponistiv;
     /*izracunavanje ponistivih neterminala*/
     for(i=0;i<128;i++)
         P[i]=0;
     do{
        ponovo=0;
        for(i=0;i<br_smena;i++){
            if(!P[L[i]]){
               ponistiv=1;
               for(j=0;j<strlen(D[i]);j++)
                   if(!P[D[i][j]])
                      ponistiv=0;
               if(ponistiv){
                  P[L[i]]=1;
                  ponovo=1;
               }
            }
        }
     }while(ponovo);
     /*izracunavanje first skupova*/
     for(i=33;i<128;i++){
         if(i<'A' || i>'Z'){
             FIRST[i][0]=i;
             FIRST[i][1]='\0';
         }else
             FIRST[i][0]='\0';
     }
     do{
        ponovo=0;
        for(i=0;i<br_smena;i++)
            for(j=0;j<strlen(D[i]);j++){
                for(k=0;k<strlen(FIRST[D[i][j]]);k++)
                     if(sadrzi(FIRST[L[i]],FIRST[D[i][j]][k])==0){
                         strncat(FIRST[L[i]],FIRST[D[i][j]]+k,1);
                         ponovo=1;
                     }
                if(!P[D[i][j]])
                   break;
            }
     }while(ponovo);
     /*izracunavanje follow skupova*/
     for(i='A';i<='Z';i++)
         FOLLOW[i][0]='\0';
     FOLLOW[L[0]][0]='@';
     FOLLOW[L[0]][1]='\0';
     do{
        ponovo=0;
        for(i=0;i<br_smena;i++)
            for(j=0;j<strlen(D[i]);j++)
                if(isupper(D[i][j])){
                   ponistiv=1;
                   for(k=j+1; ponistiv && k<strlen(D[i]) ;k++){
                       for(l=0;l<strlen(FIRST[D[i][k]]);l++)
                           if(sadrzi(FOLLOW[D[i][j]],FIRST[D[i][k]][l])==0){
                              strncat(FOLLOW[D[i][j]],FIRST[D[i][k]]+l,1);
                              ponovo=1;
                           }
                       ponistiv=P[D[i][k]];
                   }
                   if(ponistiv){
                       for(k=0;k<strlen(FOLLOW[L[i]]);k++)
                           if(sadrzi(FOLLOW[D[i][j]],FOLLOW[L[i]][k])==0){
                              strncat(FOLLOW[D[i][j]],FOLLOW[L[i]]+k,1);
                              ponovo=1;
                           }
                   }
                }
     }while(ponovo==1);
}

/*upisivanje rezultata rada u izlaz.txt*/
void upisi(){
     FILE *izlaz;
     int i, upisan[128];
     izlaz=fopen("izlaz.txt","w");
     /*ponistivi neterminali*/
     for(i=0;i<128;i++)
         upisan[i]=0;
     fprintf(izlaz,"PONISTIVI:");
     for(i=0;i<br_smena;i++)
         if(!upisan[L[i]]&&P[L[i]]){
            fprintf(izlaz," %c",L[i]);
            upisan[L[i]]=1;
         }
     /*first skupovi*/
     for(i=0;i<128;i++)
         upisan[i]=0;
     for(i=0;i<br_smena;i++)
         if(!upisan[L[i]]){
            fprintf(izlaz,"\nFIRST(%c) = {%s}",L[i],FIRST[L[i]]);
            upisan[L[i]]=1;
         }
     /*follow skupovi*/
     for(i=0;i<128;i++)
         upisan[i]=0;
     for(i=0;i<br_smena;i++)
         if(!upisan[L[i]]){
            fprintf(izlaz,"\nFOLLOW(%c) = {%s}",L[i],FOLLOW[L[i]]);
            upisan[L[i]]=1;
         }
     fclose(izlaz);
}

/*glavni program*/
main(){
       ucitaj();
       follow();
       upisi();
}

